<template>
    <div>
        <el-card v-loading="loading" class="flex items-center items-justify" style="width:600px;">
            <h1>{{ isEditing ? "Update" : "Create" }}</h1>
            <el-form
                
                ref="formRef"
                :model="form"
                :size="formSize"
                :rules="rules"
                label-position="top"
            >
                <el-form-item label="Thumbnail">
                    <div
                        class="image-uploader-container flex items-center justify-center margin-bottom-md"
                    >
                        <img :src="picturePreview" id="picture-preview" />
                        <input
                            type="file"
                            id="picture"
                            accept="image/*"
                            @change="handlePictureChange"
                            class="hidden-input"
                        />
                    </div>
                </el-form-item>

                    <el-form-item label="Category">
                        <el-select v-model="category_value" clearable placeholder="Select">
                        <el-option
                        v-for="item in options"
                        :key="item.value"
                        :label="item.label"
                        :value="item.value"
                        />
                    </el-select>
                    </el-form-item>
            
                <template v-for="field in formFields">
                    <el-form-item class="no-margin margin-bottom-md"
                        v-if="
                            field.type === 'input' || field.type === 'textarea'
                        "
                        :label="field.label"
                        :prop="field.prop"
                        :rules="field.rules"
                    >
                        <el-input
                            :type="field.type"
                            v-model="form[field.prop]"
                        ></el-input>
                    </el-form-item>

                    <el-form-item
                        class="no-margin margin-bottom-sm"
                        v-if="field.type === 'input-number'"
                        :label="field.label"
                        :prop="field.prop"
                        :rules="field.rules"
                    >
                        <el-input-number
                            :step="0.01"
                            v-model="form[field.prop]"
                        ></el-input-number>
                    </el-form-item>
                </template>
                <el-form-item label="Available" class="no-margin margin-bottom-sm">
                    <el-switch id="available" v-model="available" />
                </el-form-item>
                <el-form-item>
                    <el-button @click="saveProduct">{{
                        isEditing ? "Update" : "Create"
                    }}</el-button>
                    <el-button
                        @click="
                            () => {
                                isEditing ? getSingleData() : resetForm();
                            }
                        "
                        >Reset</el-button
                    >
                </el-form-item>
            </el-form>
        </el-card>
    </div>
</template>

<style scoped>
#picture-preview {
    width: 300px;
    height: 250px;
    border-radius: 1rem;
    box-shadow: 1px 1px 1px black;
    background-color: var(--el-color-primary);
}

.image-uploader-container {
    position: relative;
    width: 300px;
}
.input-label {
    position: relative;
    display: inline-block;
    cursor: pointer;
}

.hidden-input {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    opacity: 0;
    cursor: pointer;
}
</style>

<script setup>
import { ref, defineProps, watch } from "vue";
import { useRouter } from "vue-router";

import itemHandler from "../../helpers/itemHandler";
import formHelper from "../../helpers/form";

const router = useRouter();

const { formSize, formRef, form, resetForm } = formHelper;

const { loading, processItem } = itemHandler;

const category_value = ref('')
const options = [
  {
    value: 'PANCIT',
    label: 'PANCIT',
  },
  {
    value: 'SILOG MEAL',
    label: 'SILOG MEAL',
  },
  {
    value: 'SHORT ORDER',
    label: 'SHORT ORDER',
  },
  {
    value: 'DRINKS',
    label: 'DRINKS',
  }
]


const props = defineProps([
    "formFields",
    "isEditing",
    "method",
    "url",
    "getSingleData",
    "picturePreview",
    "available",
]);

const picture = ref(null);

const picturePreview = ref(props.picturePreview); // Assign the prop to the ref
const available = ref(props.available);

watch(
    () => props.picturePreview,
    (newPicturePreview) => {
        picturePreview.value = newPicturePreview;
    }
);

watch(
    () => props.available,
    (newAvailable) => {
        available.value = newAvailable;
    }
);

const handlePictureChange = (event) => {
    const file = event.target.files[0];

    picture.value = file;

    // Create a FileReader instance
    const reader = new FileReader();

    // Read the file and generate a preview URL
    reader.onload = () => {
        picturePreview.value = reader.result;
    };

    // Read the file as a data URL
    reader.readAsDataURL(file);
};

const payloadProperties = props.formFields.map(({ prop }) => prop);
payloadProperties.push("available");
payloadProperties.push("picture");


const saveProduct = async () => {
    
    await processItem(
        props.url,
        props.method,
        payloadProperties,
        picture.value,
        available.value,
        category_value.value,
        router
    );
    resetForm();

    // await makeRequest(props.url, props.method, payloadProperties, picture.value, available.value);
};
</script>
